package dev.fyloz.trial.colorrecipesexplorer.exception

import dev.fyloz.trial.colorrecipesexplorer.exception.model.ModelException
import dev.fyloz.trial.colorrecipesexplorer.model.Model

class EntityAlreadyExistsException(
    modelType: Class<out Model>,
    val identifierType: IdentifierType,
    val identifierName: String?,
    val requestedId: Any
) : ModelException(modelType) {
    constructor(modelType: Class<out Model>, identifierType: IdentifierType, requestedId: Any) : this(
        modelType,
        identifierType,
        identifierType.name,
        requestedId
    )

    constructor(exception: EntityAlreadyExistsException) : this(
        exception.type,
        exception.identifierType,
        exception.identifierName,
        exception.requestedId
    )
}

class EntityNotFoundException(
    modelType: Class<out Model>,
    val identifierType: IdentifierType,
    val requestedId: Any
) : ModelException(modelType)
