package dev.fyloz.trial.colorrecipesexplorer.repository

import dev.fyloz.trial.colorrecipesexplorer.model.Material
import dev.fyloz.trial.colorrecipesexplorer.model.MixType
import org.springframework.data.jpa.repository.Query
import org.springframework.stereotype.Repository

@Repository
interface MixTypeRepository : NamedJpaRepository<MixType> {
    /** Gets the mix type with the given [material]. */
    fun findByMaterial(material: Material): MixType?

    @Query(
        """
        select case when(count(m.id) > 0) then false else true end
        from MixType t
        left join Mix m on t.id = m.mixType.id
        where t.id = :id
    """
    )
    fun canBeDeleted(id: Long): Boolean
}
